
import 'dart:async';

import 'package:flutter/services.dart';

class SpectusTusUploader {
  static const MethodChannel _channel =
      const MethodChannel('spectus_tus_uploader');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<String?> pickVideoFromGallary() async {
    final String filePath = await _channel.invokeMethod('pickVideoFrom');
    return filePath;
  }

//uploadFileWith(fileURL: URL, fileType: String, authEmail: String, authKey: String, authToken: String,
// progressHandler : ((_ uploaded : Double, _ remaining : Double)->Void)? = nil,
// successOrFailureHandler: ((_ errorMessage : String?, _ uploadFileURL : String?)->Void)? = nil) {
  static Future<String?> uploadFileWithTUS({String? uploadURLPath,String? filePath,String? fileType,String? authEmail,String? authKey,
    String? authToken}) async
  {
    final String mediaID = await _channel.invokeMethod('uploadFileWithTUS',
        {
          "uploadURLPath": uploadURLPath,
          "filePath":filePath,
          "fileType":fileType,
          "authEmail":authEmail,
          "authKey":authKey,
          "authToken":authToken
        }
    );
    print("Back in DART: " + mediaID);
    return mediaID;
  }
}
